<template>
  <FunctionPage
    :header-text-i18n-id="`request.${certificateType}.title`"
    :show-start-over-button="subPage === RequestCertificatePage.Success || subPage === RequestCertificatePage.Error"
    :start-over-function="startOverFunction"
  >
    <v-container v-if="subPage === RequestCertificatePage.Loading">
      <v-row class="text-center">
        <v-col>
          <v-card>
            <v-card-text>
              <v-progress-circular indeterminate class="ma-auto" />
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-container>

    <v-container v-else-if="subPage === RequestCertificatePage.Request">
      <v-row>
        <v-col>
          <v-stepper
            v-model="step"
            :items="[$t(`request.common.steps.emailAddresses.title`), $t(`request.common.steps.checkRequest.title`)]"
          >
            <template #[`item.1`]>
              <v-card>
                <v-card-title>{{ $t("request.common.steps.emailAddresses.title") }}</v-card-title>
                <v-card-text>
                  <v-row>
                    <v-col>
                      <hyphenated-justified-text>
                        {{ $t(`request.${certificateType}.steps.emailAddresses.description`) }}
                      </hyphenated-justified-text>
                    </v-col>
                  </v-row>
                  <v-row>
                    <v-col>
                      <v-form ref="emailAddressesForm" validate-on="blur">
                        <slot />
                      </v-form>
                    </v-col>
                  </v-row>
                </v-card-text>
              </v-card>
            </template>
            <template #[`item.2`]>
              <v-card>
                <v-card-title>{{ $t(`request.common.steps.checkRequest.title`) }}</v-card-title>
                <v-card-text>
                  <v-row>
                    <v-col>
                      <hyphenated-justified-text>
                        {{ $t(`request.${certificateType}.steps.checkRequest.description`) }}
                      </hyphenated-justified-text>
                    </v-col>
                  </v-row>

                  <v-row>
                    <v-col>
                      <v-list>
                        <v-list-item v-if="request.identification" prepend-icon="fas fa-signature">
                          <!-- Currently, the name from the IDM is used for the certificate -->
                          <v-list-item-title>{{ store.user?.firstname }} {{ store.user?.lastname }}</v-list-item-title>
                          <v-list-item-subtitle>
                            {{ $t(`request.${certificateType}.steps.checkRequest.requestInfo.commonName`) }}
                          </v-list-item-subtitle>
                        </v-list-item>
                        <v-list-item
                          v-for="(emailAddress, idx) in request.emailAddresses"
                          :key="idx"
                          density="compact"
                          :prepend-icon="`${isPrimaryAddress(emailAddress, idx) ? 'fas' : 'far'} fa-envelope`"
                        >
                          <v-list-item-title>
                            {{ emailAddress }}
                          </v-list-item-title>
                          <v-list-item-subtitle>
                            {{
                              isPrimaryAddress(emailAddress, idx)
                                ? $t(`request.common.steps.checkRequest.requestInfo.primaryEmailAddress`)
                                : $t(`request.common.steps.checkRequest.requestInfo.emailAddress`)
                            }}
                          </v-list-item-subtitle>
                        </v-list-item>
                      </v-list>
                    </v-col>
                  </v-row>
                </v-card-text>
              </v-card>
            </template>
            <template #next>
              <v-btn v-if="step === 1" :disabled="!request.formValid" @click="step++">{{
                $t("$vuetify.stepper.next")
              }}</v-btn>
              <v-btn
                v-if="step === 2"
                variant="elevated"
                color="primary"
                :loading="submitting"
                :disabled="false"
                @click="requestCertificate"
                >{{ $t("$vuetify.stepper.submit") }}</v-btn
              ></template
            >
          </v-stepper>
        </v-col>
      </v-row>
    </v-container>

    <v-container v-else-if="subPage === RequestCertificatePage.Success">
      <v-card>
        <v-card-title>
          <icon-with-text icon="circle-check" color="green" size="x-small" class="justify-center">
            {{ $t(`request.common.success.title`) }}
          </icon-with-text>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col>
                <hyphenated-justified-text>
                  {{ $t(`request.common.success.text`) }}
                </hyphenated-justified-text>
              </v-col>
            </v-row>
            <v-row>
              <v-col class="text-center">
                <v-btn
                  color="secondary"
                  variant="elevated"
                  :href="$t(`request.common.success.instructionsUrl`)"
                  target="_blank"
                  >{{ $t(`request.common.success.instructionsButton`) }}</v-btn
                >
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
      </v-card>
    </v-container>

    <v-container v-else-if="subPage === RequestCertificatePage.Error">
      <v-card>
        <v-card-title>
          <icon-with-text icon="circle-xmark" color="red" size="x-small" class="justify-center">{{
            error ? $t(`request.common.error.title`) : $t(`request.${certificateType}.missingIdentification.title`)
          }}</icon-with-text>
        </v-card-title>
        <v-card-text>
          <v-container class="text-center">
            <v-row>
              <v-col>
                <hyphenated-justified-text>
                  {{ error ? error.getLocalized($t) : $t(`request.${certificateType}.missingIdentification.text`) }}
                </hyphenated-justified-text>
              </v-col>
            </v-row>
            <v-row dense>
              <v-col>
                <hyphenated-justified-text v-if="error">
                  {{ $t(`request.${certificateType}.error.text`) }}
                </hyphenated-justified-text>
              </v-col>
            </v-row>
            <v-row>
              <v-col class="text-center">
                <v-btn
                  color="secondary"
                  variant="elevated"
                  :href="$t(`request.common.error.serviceDeskUrl`)"
                  target="_blank"
                  >{{ $t(`request.common.error.serviceDeskButton`) }}</v-btn
                >
              </v-col>
              <v-col v-if="certificateType !== 'functional'" class="text-center">
                <v-btn color="primary" variant="elevated" href="/request-functional">{{
                  $t(`request.${certificateType}.error.functionalInsteadButton`)
                }}</v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
      </v-card>
    </v-container>
  </FunctionPage>
</template>
<script lang="ts">
import { defineComponent } from "vue";
import { Identification, VFormType } from "@/ts/types";
import { requestBackend, store } from "@/ts/common";
import IconWithText from "@/components/IconWithText.vue";
import HyphenatedJustifiedText from "@/components/HyphenatedJustifiedText.vue";
import FunctionPage from "@/components/FunctionPage.vue";
import { APIError } from "@/ts/errorTypes";

export enum RequestCertificateSubPage {
  Loading,
  Request,
  Success,
  Error,
}

export type RequestCertificatePageData = {
  subPage: RequestCertificateSubPage;
  step: number;
  request: {
    identification: Identification | null;
    primaryEmailAddress: string | null;
    emailAddresses: Array<string>;
    formValid: boolean;
  };
  submitting: boolean;
  error: APIError | null;
  $refs?: {
    emailAddressesForm: VFormType;
  };
};

export default defineComponent({
  components: { FunctionPage, HyphenatedJustifiedText, IconWithText },
  props: {
    certificateType: {
      type: String,
      required: true,
    },
    certificateRequestBodyGetter: {
      type: Function,
      required: true,
    },
    startOverExtraSteps: {
      type: Function,
      required: true,
    },
  },
  setup() {
    return {
      store,
      Identification,
      RequestCertificatePage: RequestCertificateSubPage,
    };
  },
  data(): RequestCertificatePageData {
    return {
      subPage: RequestCertificateSubPage.Loading as RequestCertificateSubPage,
      step: 1,
      request: {
        identification: null as Identification | null,
        primaryEmailAddress: null as string | null,
        emailAddresses: [] as Array<string>,
        formValid: true,
      },
      submitting: false,
      error: null as APIError | null,
    };
  },
  methods: {
    requestCertificate: function () {
      this.submitting = true;
      requestBackend<null>(`/request/${this.certificateType}`, this.certificateRequestBodyGetter())
        .then(
          () => {
            this.error = null;
            this.subPage = RequestCertificateSubPage.Success;
          },
          (error: APIError) => {
            this.error = null;
            this.error = error;
            this.subPage = RequestCertificateSubPage.Error;
          }
        )
        .finally(() => {
          this.submitting = false;
        });
    },
    startOverFunction: function () {
      this.subPage = RequestCertificateSubPage.Loading;
      this.step = 1;
      this.error = null;
      this.startOverExtraSteps();
    },
    isPrimaryAddress(emailAddress: string, idx: number) {
      if (this.request.primaryEmailAddress && this.request.primaryEmailAddress === emailAddress) {
        // The address matches the primary address
        return true;
      } else if (!this.request.primaryEmailAddress && idx === 0) {
        // There is no defined primary address, but the address is the first in the list
        return true;
      }

      return false;
    },
  },
});
</script>

<style>
@media (max-width: 599px) {
  .v-stepper-window {
    margin: 0.5rem !important;
  }

  .v-stepper-item__content {
    display: none;
  }
}
</style>
